﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DeviceWatcher
{

    
    public enum CMD : uint
    {
        APPEND              = 4294967070,
        BGCOLOR             = 4294967049,
        BITMAP_TRANSFORM    = 4294967073,
        BUTTON              = 4294967053,
        CALIBRATE           = 4294967061,
        CLOCK = 4294967060,
        COLDSTART = 4294967090,
        CRC = 4294967043,
        DIAL = 4294967085,
        DLSTART = 4294967040,
        EXECUTE = 4294967047,
        FGCOLOR = 4294967050,
        GAUGE = 4294967059,
        GETMATRIX = 4294967091,
        GETPOINT = 4294967048,
        GETPROPS = 4294967077,
        GETPTR = 4294967075,
        GRADCOLOR = 4294967092,
        GRADIENT = 4294967051,
        HAMMERAUX = 4294967044,
        IDCT = 4294967046,
        INFLATE = 4294967074,
        INTERRUPT = 4294967042,
        KEYS = 4294967054,
        LOADIDENTITY = 4294967078,
        LOADIMAGE = 4294967076,
        LOGO = 4294967089,
        MARCH = 4294967045,
        MEMCPY = 4294967069,
        MEMCRC = 4294967064,
        MEMSET = 4294967067,
        MEMWRITE = 4294967066,
        MEMZERO = 4294967068,
        NUMBER = 4294967086,
        PROGRESS = 4294967055,
        REGREAD = 4294967065,
        ROTATE = 4294967081,
        SCALE = 4294967080,
        SCREENSAVER = 4294967087,
        SCROLLBAR = 4294967057,
        SETFONT = 4294967083,
        SETMATRIX = 4294967082,
        SKETCH = 4294967088,
        SLIDER = 4294967056,
        SNAPSHOT = 4294967071,
        SPINNER = 4294967062,
        STOP = 4294967063,
        SWAP = 4294967041,
        TEXT = 4294967052,
        TOGGLE = 4294967058,
        TOUCH_TRANSFORM = 4294967072,
        TRACK = 4294967084,
        TRANSLATE = 4294967079
    }
 
    class CoPro :  EveDL
    {



        //public void Flush()
        //{


        //}




        //
        /// <summary>
        ///  Co processor instructions
        /// /
        /// </summary>
        public class Flush : FTEveCmd
        {

            override public uint Size()
            {
                return 0;
            }

            override public byte[] ToBuffer()
            {
              return new byte[]{ };  
            }
        }


        //
        /// <summary>
        ///  Co processor instructions
        /// /
        /// </summary>
        public class Getpoint : FTEveCmd
        {
            public CMD Cmd()
            {
                throw new NotImplementedException();
            }

            override public uint Size()
            {
                throw new NotImplementedException();
            }

            override public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }

        public class Dlstart : FTEveCmd
        {
            const CMD c = CMD.DLSTART;
            const uint size = 4;
            public Dlstart()
            {

            }
            public CMD Cmd()
            {
                return c;
            }

            override public uint Size()
            {
                return size;
            }

            override public byte[] ToBuffer()
            {
                return CMDToBuffer(c);
            }
        }
        public class Swap : FTEveCmd
        {
            const CMD c = CMD.SWAP;
            const uint size = 4;

            public Swap()
            {
                            }
            public CMD Cmd()
            {
                return c;
            }

            override public uint Size()
            {
                return size;
            }

            override public byte[] ToBuffer()
            {
                return CMDToBuffer(c);
            }
        }
        public class Text : FTEveCmd
        {



            CMD c;
            uint x;
            uint y;
            uint font;
            byte options;
            string text;


            public Text (uint inx, uint  iny, uint infont, byte inoptions, string intext)
            {
                x = inx;
                y = iny;
                font = infont;
                options = inoptions;
                text = intext;                   
                //, FT_CMD_SIZE * 3 + strlen(s) + 1);
                c = CMD.TEXT;
                
            }

            override public uint Size()
            {
                throw new NotImplementedException();
            }

            override public byte[] ToBuffer()
            {
                int num;
                //Ft_Gpu_CoCmd_StartFunc(phost, FT_CMD_SIZE * 3 + strlen(s) + 1);
                //Ft_Gpu_Copro_SendCmd(phost, CMD_TEXT);
                //Ft_Gpu_Copro_SendCmd(phost, (((ft_uint32_t)y << 16) | (x & 0xffff)));
                //Ft_Gpu_Copro_SendCmd(phost, (((ft_uint32_t)options << 16) | (font & 0xffff)));
                //Ft_Gpu_CoCmd_SendStr(phost, s);
                //Ft_Gpu_CoCmd_EndFunc(phost, (FT_CMD_SIZE * 3 + strlen(s) + 1));
                byte[] buff = { (byte)( ((uint)c & 0x000000FF)     ),
                                (byte)( ((uint)c & 0x0000FF00) >> 8),
                                (byte)( ((uint)c & 0x00FF0000) >> 16),
                                (byte)( ((uint)c & 0xFF000000) >> 24 )
                };

                return buff;

                throw new NotImplementedException();
            }

            public CMD Cmd()
            {
                return c;
            }
        }
        public class Toggle : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            override public uint Size()
            {
                throw new NotImplementedException();
            }

            override public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }

#if laters

        class Append : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Bgcolor : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Bitmap_transfor : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Button : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Calibrate : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Clock : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Coldstart : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Crc : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Dial : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }

        class Execute : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Fgcolor : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Gauge : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Getmatrix : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
       
        class Getprops : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Getptr : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Gradcolor : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Gradient : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Hammeraux : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Idct : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Inflate : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Interrupt : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Keys : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Loadidentity : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Loadimage : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Logo : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class March : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Memcpy : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Memcrc : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Memset : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Memwrite : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Memzero : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Number : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Progress : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Regread : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Rotate : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Scale : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Screensaver : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Scrollbar : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Setfont : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Setmatrix : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Sketch : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Slider : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Snapshot : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Spinner : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Stop : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }


       
        class Touch_transform : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Track : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
        class Translate : FTEveCmd
        {
            public CMD cmd()
            {
                throw new NotImplementedException();
            }

            public uint Size()
            {
                throw new NotImplementedException();
            }

            public byte[] ToBuffer()
            {
                throw new NotImplementedException();
            }
        }
#endif //laters

        public abstract  class FTEveCmd : IFTEveCmd
        {
            virtual public  byte [] CMDToBuffer ( CMD c )
            {

                byte[] buff = {     (byte)( ((uint)c & 0x000000FF)     )     ,
                                    (byte)( ((uint)c & 0x0000FF00) >> 8)     ,
                                    (byte)( ((uint)c & 0x00FF0000) >> 16)    ,
                                    (byte)( ((uint)c & 0xFF000000) >> 24 )   
                    };

                return buff;


            }

            public abstract uint Size();
            public abstract byte[] ToBuffer();
        }
    }
}
